STRIP(1)

NAZWA
strip - Usuwa symbole z plików obiektowych

SKŁADNIA
strip [-F bfdname |--target=bfdname]
      [-I bfdname |--input-target=bfdname]
      [-O bfdname |--output-target=bfdname]
      [-s|--strip-all]
      [-S|-g|-d|--strip-debug]
      [--strip-dwo]
      [-K symbolname |--keep-symbol=symbolname]
      [-N symbolname |--strip-symbol=symbolname]
      [-w|--wildcard]
      [-x|--discard-all] [-X |--discard-locals]
      [-R sectionname |--remove-section=sectionname]
      [--remove-relocations=sectionpattern]
      [-o file] [-p|--preserve-dates]
      [-D|--enable-deterministic-archives]
      [-U|--disable-deterministic-archives]
      [--keep-file-symbols]
      [--only-keep-debug]
      [-v |--verbose] [-V|--version]
      [--help] [--info]
      objfile...

OPIS
GNU strip usuwa wszystkie symbole z plików obiektowych objfile. Lista plików obiektowych może zawierać archiwa. Podany musi być przynajmniej jeden plik obiektowy.

strip modyfikuje pliki podane w argumencie - nie zapisuje zmodyfikowanych kopii pod innymi nazwami.

OPCJE

-F bfdname
--target=bfdname
    Traktuje oryginalny objfile jak plik obiektowy w formacie bfdname i zapisuje go w tym samym formacie.

--help
    Wypisuje sposób użycia strip z wiersza poleceń i kończy pracę programu.

--info
    Wyświetla listę wszystkich dostępnych architektur i formatów plików obiektowych.

-I bfdname
--input-target=bfdname
    Traktuje oryginalny objfile jako plik o formacie kodu obiektowego bfdname.

-O bfdname
--output-target=bfdname
    Zastępuje objfile plikiem w formacie wyjściowym bfdname.

-R sectionname
--remove-section=sectionname
    Oprócz sekcji które normalnie są usuwane, usuwa z pliku wyjściowego także każdą sekcję o nazwie sectionname. Opcja ta może być podana więcej niż raz. Proszę zauważyć, że jej nieodpowiednie używanie może spowodować, że plik obiektowy będzie bezużyteczny. sectionname może się kończyć znakiem dopasowania *. W takim przypadku zostaną usunięte sekcje o nazwach zaczynających się od sectionname.

    Jeśli pierwszym znakiem sctionname jest znak wykrzyknika ("!"), to pasujące sekcje nie będą usuwane, nawet jeśli poprzednie użycie opcji --remove-section w tej samej linii poleceń spowodowałoby ich usunięcie. Na przykład:

     --remove-section=.text.* --remove-section=!.text.foo

    usunie wszystkie sekcje pasujące do wzorca ".text.*", z wyjątkiem sekcji ".text.foo".

--remove-relocations=sectionpattern
    Usuwa z pliku wynikowego relokacje w każdej sekcji pasującej do sectionpattern. Opcja ta może być podana więcej niż raz. Proszę zauważyć, że jej nieodpowiednie używanie może spowodować, że plik obiektowy będzie bezużyteczny. sectionpattern może zawierać znaki dopasowania. Na przykład:

     --remove-relocations=.text.*

    usunie wszystkie relokacje z wszystkich sekcji pasujących do wzorca ".text.*".

    Jeśli pierwszym znakiem sectionpattern jest znak wykrzyknika ("!"), to relokacje nie będą usuwane z pasujących sekcje, nawet jeśli poprzednie użycie opcji --remove-relocations w tej samej linii poleceń spowodowałoby usunięcie relokacji. Na przykład:

     --remove-relocations=.text.* --remove-relocations=!.text.foo

    usunie wszystkie relokacje z sekcji pasujących do wzorca ".text.*", z wyjątkiem relokacji w sekcji ".text.foo".

-s
--strip-all
    Usuwa wszystkie symbole.

-g
-S
-d
--strip-debug
    Usuwa tylko symbole debugowe.

--strip-dwo
    Usuwa zawartość wszystkich sekcji DWARF .dwo, pozostawiając pozostałe sekcje i wszystkie symbole. Więcej informacji można znaleźć w opisie tej opcji w rozdziale objcopy.

--strip-unneeded
    Usuwa wszystkie symbole, które nie są potrzebne do przetwarzania relokacji.

-K symbolname
--keep-symbol=symbolname
    Podczas usuwania symboli zachowuje symbol symbolname, nawet jeśli normalnie byłby usunięty. Opcja ta może być podawana więcej niż jeden raz.

-N symbolname
--strip-symbol=symbolname
    Usuwa symbol symbolname z pliku źródłowego. Opcja ta może być podawana więcej niż raz i łączona z innymi opcjami usuwania z wyjątkiem -K.

-o plik
    Umieszcza ogołocone wyjście w pliku bez zastępowania istniejącego pliku. Z tym argumentem podany może być tylko jeden argument objfile.

-p
--preserve-dates
    Zachowuje prawa dostępu i daty modyfikacji pliku.

-D
--enable-deterministic-archives
    Działa w trybie deterministycznym. Podczas kopiowania członków archiwum i zapisywania indeksu archiwum używa wartości zero w polach UID, GID, znacznika czasowego, a także używa jednolitych praw dostępu do wszystkich plików.

    Jeśli binutils zostało skonfigurowane z opcją --enable-deterministic-archives, to jest to zachowanie domyślne. Można je wyłączyć za pomocą poniżej opisanej opcji -U.

-U
--disable-deterministic-archives
    Nie działa w trybie deterministycznym. Jest to odwrotność opcji -D opisanej powyżej: podczas kopiowania członków archiwum i zapisywania indeksu archiwum używa właściwych wartości pól UID, GID, znacznika czasowego i praw dostępu do pliku.

    Jest to zachowanie domyślne, o ile binutils nie został skonfigurowany z --enable-deterministic-archives.

-w
--wildcard
    Pozwala na użycie wyrażeń regularnych w argumentach symbolname pozostałych opcji linii poleceń. W dowolnej części nazwy symbolu można użyć znaku zapytania ("?"), gwiazdki ("*"), odwrotnego ukośnika ("\") oraz operatora nawiasów kwadratowych ("[]"). Jeśli pierwszym znakiem nazwy symbolu jest wykrzyknik ("!"), to dla tego symbolu przełącznik ma odwrotne znacznie. Na przykład:

     -w -K !foo -K fo*

    spowoduje, że strip zachowa tylko te symbole, które zaczynają się od liter "fo", ale usunie symbol "foo".

-x
--discard-all
    Usuwa symbole nieglobalne.

-X
--discard-locals
    Usuwa generowane przez kompilator symbole lokalne. (Zaczynają się zwykle od L lub .).

--keep-file-symbols
    Podczas usuwania symboli z pliku, na przykład za pomocą --strip-debug lub --strip-unneeded, pozostawia wszystkie symbole określające nazwy plików źródłowych, które w przeciwnym wypadku zostałyby usunięte.

--only-keep-debug
    Usuwa symbole z pliku, czyszcząc zawartość wszystkich sekcji, które nie zostałyby wyczyszczone przez --strip-debug, ale pozostawiając sekcje debugowania nienaruszone. W plikach ELF pozostawia to także sekcje notatek.

    Uwaga: pozostawiane są nagłówki usuniętych sekcji, włączając to ich rozmiary, ale sama zawartość sekcji jest usuwana. Nagłówki sekcji są pozostawiane po to, żeby inne narzędzia mogły sparować plik debuginfo z rzeczywisty programem wykonywalnym nawet wtedy, gdy ten program został realokowany do innej przestrzeni adresów,

    Założenie jest takie, że ta opcja będzie używana łącznie z --add-gnu-debuglink, aby utworzyć dwuczęściowy plik wykonywalny. Pierwsza część to program binarny pozbawiony zbędnych symboli, który zajmuje mniej miejsca w pamięci RAM i w pakiecie dystrybucji systemu, a druga część zawiera plik informacji debugowania, potrzebny tylko wtedy, gdy wymagane do debugowanie aplikacji. Sugerowany sposób tworzenia tych plików jest następujący:

    1. Skonsoliduj program wykonywalny, jak to się zwykle robi. Zakładając, że jest to nazwane
        "foo", to...

    1. Uruchom "objcopy --only-keep-debug foo foo.dbg", aby
        utworzyć plik zawierający informacje debugowania.

    1. Uruchom "objcopy --strip-debug foo", aby utworzyć
        wyczyszczony ze zbędnych sekcji program wykonywalny.

    1. Uruchom "objcopy --add-gnu-debuglink=foo.dbg foo",
        aby dodać informacje debugowania do programu wykonywalnego wyczyszczonego ze zbędnych sekcji.

    Uwaga: Wybór ".dbg" jako rozszerzenia plików zawierających informacje debugowania jest całkowicie przypadkowy. Także krok "--only-keep-debug" jest opcjonalny. Zamiast niego można wykonać:

    1. Skonsoliduj program wykonywalny, jak to się zwykle robi.
    1. Skopiuj "foo" do "foo.full"
    1. Uruchom "strip --strip-debug foo"
    1. Uruchom "objcopy --add-gnu-debuglink=foo.full foo"

    Oznacza to, że plik wskazywany przez --add-gnu-debuglink może być pełnym programem wykonywalnym. Nie musi to być plik tworzony przez opcję --only-keep-debug.

    Uwaga: ta opcja jest przeznaczona do użycia tylko z całkowicie skonsolidowanymi plikami. Nie ma ona sensu w przypadku plików obiektowych, w których informacje debugowania mogą nie być kompletne. Poza tym właściwość gnu_debuglink obecnie dopuszcza wystąpienie nazwy tylko jednego pliku zawierającego informacjami debugowania, czyli nie pozwala na wiele plików, z których każdy zawierałby informacje debugowania dla osobnego pliku obiektowego.

-V
--version
    Wypisuje numer wersji programu strip.

-v
--verbose
    Gadatliwe wyjście: wyświetla wszystkie zmodyfikowane pliki obiektowe. W wypadku archiwów, strip -v wyświetla wszystkich członków archiwum.

@plik
    Czyta opcje linii poleceń z podanego pliku. Przeczytane opcje są wstawiane w miejsce oryginalnej opcji @plik. Jeśli plik nie istnieje lub nie może być odczytany ta opcja jest traktowana dosłownie i nie jest usuwana.

    Opcje w pliku są rozdzielane białymi znakami. Biały znak może wystąpić w opcji, jeśli cała opcja zostanie ujęta w pojedyncze albo podwójne cudzysłowy. Można dodać dowolny znak (włączając w to znak odwrotnego ukośnika), poprzedzając go znakiem odwrotnego ukośnika. Plik może również zawierać dodatkowe opcje @plik - w takim przypadku każda z takich opcji będzie przetwarzana rekurencyjnie.

ZOBACZ TAKŻE
wpisy info binutils.

PRAWA AUTORSKIE
Copyright (c) 1991-2017 Free Software Foundation, Inc.

Zezwala się na kopiowanie, rozpowszechnianie i/lub modyfikowanie tego dokumentu na warunkach Licencji Wolnej Dokumentacji GNU (GNU Free Documentation License) w wersji 1.3 lub jakiejkolwiek nowszej wersji opublikowanej przez Fundację Wolnego Oprogramowania, przy czym Sekcjami niezmiennymi są "GNU General Public License" i "GNU Free Documentation License", bez treści przedniej lub tylnej strony okładki. Egzemplarz licencji zamieszczono w sekcji zatytułowanej "GNU Free Documentation License".

TŁUMACZENIE
Autorami polskiego tłumaczenia niniejszej strony podręcznika man są: Przemek Borys (PTM) <pborys@dione.ids.pl> i Robert Luberda <robert@debian.org>.

Polskie tłumaczenie jest częścią projektu manpages-pl; uwagi, pomoc, zgłaszanie błędów na stronie http://sourceforge.net/projects/manpages-pl/. Jest zgodne z wersją 2.27.90.20170124 oryginału.